#$Id: sudoscript.spec.src,v 1.4 2003/06/23 19:25:24 hbo Exp $
ExclusiveArch: noarch
Name: sudoscript
Version: 2.1.1
Release: 1
Copyright: GPL, Artistic
Summary: Sudoscript provides a shell run with sudo and scripted to a log
Group: Applications/System
Source: sudoscript-2.1.1.tar.bz2
BuildPreReq: rpm-devel perl

Requires: sudo perl chkconfig
Provides: sudoscriptd sudoshell ss
BuildRoot: /var/tmp/sudoscript
AutoReqProv: no
%description
The sudoscript package provids two programs. Sudoshell runs a shell
with sudo (or just a shell, if root runs it) that uses the script(1)
command to log to a FIFO. The purpose is to provide a root shell, to
users who successfully insist on it, that preserves an audit trail.

Sudoscriptd is a daemon that opens FIFOs in a private directory, then
waits for a sudoshell to start. When it does, sudoscriptd forks a
session daemon that opens another FIFO, which sudoshell uses as the
typescript. The session daemon tags the data with a session ID, and
passes it on to a log file daemon. This daemon merges the data onto a
log file named /var/log/sudocript, after time-stamping it. When the
log file size exceeds 2MB, the log file daemon rotates it and forks a
child to gzip it. At most, ten of these gzipped files are kept around




%prep

%setup

%build
make doc

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8

make DESTDIR=$RPM_BUILD_ROOT INSTALL=install TAR=tar RM=rm install

%clean
rm -rf $RPM_BUILD_ROOT

%post
chkconfig --add sudoscriptd

%preun

%files
%defattr(-,root,root)
%doc README
%doc INSTALL
%doc SECURITY
%doc SUDOCONFIG
%doc PORTING
%doc PROBLEMS
%doc CHANGELOG
%doc RELEASENOTES
%doc PORCMOLSULB.xml
%doc PORCMOLSULB.html
%doc PORCMOLSULB.pdf
%doc sudoscriptd-src.html
%doc sudoshell-src.html
%doc sudoscript.8.html
%doc sudoscriptd.8.html
%doc Sudoscript.3pm.html
%doc sudoshell.1.html
%doc 2.0arch.xml
%doc 2.0arch.html
%doc 2.0arch.gif
%doc xsl/egbokdoc.xsl
%doc xsl/egbokdoc2fop.xsl
%doc dtd/egbokdoc.dtd
%config /etc/init.d/sudoscriptd
/usr/bin/sudoshell
/usr/sbin/sudoscriptd
/usr/bin/ss
/usr/lib/sudoscript/Sudoscript.pm
/usr/share/man/man1/sudoshell.1.gz
/usr/share/man/man1/ss.1.gz
/usr/share/man/man8/sudoscriptd.8.gz
/usr/share/man/man8/sudoscript.8.gz
/usr/share/man/man3/Sudoscript.3pm.gz



%define date    %(echo `LC_ALL="C" date +"%a %b %d %Y"`)


%changelog
*Mon Jun 23 2003 hbo
  Add NetBSD support
  Add binary packages and source ports for *BSD
  Rename sudoscripters group to ssers
  Substantial rewrite of INSTALL document
  Add RELEASENOTES document
  Force deletion and recreation of /var/run/sudoscript on daemon start
  sudoscript-2.1.1 release
*Fri Jun 13 2003 hbo
  Add Solaris package build to Makefile
  Minor tweak to sudoscriptd-in to make fifodir into a variable
  sudoscript-2.1.0 release
*Wed May 28 2003 hbo
  Add HP-UX install instructions to INSTALL
  bump rpm version by one to indicated doc change
  sudoscript-2.1.0beta1 release
*Thu May 22 2003 hbo
	Implement non-root shells from idea by Donny Jekels
	Check for running daemon on damon startup
	Because of above, make a Sudoscript.pm class for shared code.
	use warnings
	Close stdin, stdout on each daemon
	redirect stderr to log files in /var/run/sudoscript
	Race loss by ss still a problem; implement fix
	Add -k switch to daemon to kill current daemon
	Extensively rework documentation
	Add HP-UX support per Donny Jekels changes
	
*Mon Dec 16 2002 hbo
	Sudoscript 2.0.3 release
*Mon Dec 16 2002 hbo
	Fix bug where ss lost race with logger to set HUP signal handler under heavy system load.
	Merge patches from Rene Uittenbogaard fixing spelig airurs and tweaking Linux init script
*Thu Sep 12 2002 hbo
	Sudoscript 2.0.2 release
*Thu Sep 12 2002 hbo
	Fix bug where logging timestamp was off after August
	of each year (it looked strange in August as well).
*Thu Sep 5 2002 hbo
	Sudoscript 2.0.1 release
*Wed Sep 4 2002 hbo
	Set $0 so ps shows which daemons are running.
*Wed Sep 4 2002 hbo
	Fix bug in log rotate that resulted in zombie compressors
*Tue Jun 25 2002 hbo
	Remove Irix from pod, PORTING and INSTALL
*Tue Jun 25 2002 hbo
	Document the --datefmt switch to sudoscriptd
*Sun Jun 16 2002 hbo
	Add LICENSE, Artistic GPLv1 and GPLv2. Together these files
	spell out the dual Perl-like license used by sudoscript
*Tue Jun 11 2002 hbo  sudoscript v 2.0.0beta2
	Use 'script -f' to tell script to flush buffers on Linux.
	Turn off buffering on the MERGEFIFO on all platforms.
*Tue Jun 11 2002 hbo 
	Add a logfile announcement of the logger daemon.
	Modify Merger logfile announcement.
*Tue Jun 11 2002 hbo 
	Add a --datefmt= flag to sudoscriptd controlling the leading
	timestamp in the private log file. Choices are: 
	  --datefmt=long gives 'Day Mon dd hh:mm:ss TZ ccyy'.
	  --datefmt=sortable gives 'ccyymmddhhmmss'. 
	  Anything else (inc. no switch) gives 'Day Mon dd hh:mm:ss'.
*Tue Jun 11 2002 hbo
	Fixed a bug where ss would only look at the first line of
	ps output when looking for sudoscriptd. Only seemed to
	be a problem on BSD platforms, but maybe that was just my luck.
*Tue Jun 4 2002 hbo  sudoscript v 2.0.0beta1
	Shorten timestamp now that logs also include session ID
*Sun Jun 2 2002 hbo
	Fix bug opening FIFO for R/W that prevented system from working
	on OpenBSD
*Thu May 23 2002 hbo sudoscript v 2.0.0alpha4
	Ripped out timer code that caused "interrupted system call"
	error in merger daemon on Solaris
	Made rotator/compressor do a setsid() to avoid zombies
*Wed May 22 2002 hbo sudoscript v 2.0.0alpha3
	Fixed Solaris and Irix init scripts to use -HUP.
	Fixd speling uf roundebooz
	Added Tommy Smith to contributors
	Tweaked POD a little
*Tue May 21 2002 hbo sudoscript v 2.0.0alpha2
	Fixed bug in merger that resulted in 100% CPU utilization
	Fixed Linux init script to kill -HUP the daemon, triggering 
	the shutdown code
	alpha2 denoted in RPM version. Tarball name not changing
*Tue May 21 2002 hbo sudoscript v 2.0.0alpha
*Mon May 20 2002 hbo
	Implemented 2.0 architecture. Daemon split into
	three sections. The master daemon forks a back-end logger
	to manage the log file. It then opens a front end FIFO,
	When sudoshell runs, it contacts the master daemon via this FIFO,
	then does a Posix::pause with a SIGHUP handler. The master daemon
	forks a session logger, which creates another FIFO whose name is
	based on sudoshell's user and PID. It sends a SIGHUP to sudoshell
	then goes to read the FIFO. Sudoshell wakes up and invokes script(1)
	on the session FIFO. The session logger tags data it receives with 
	a session ID, then writes it to the FIFO owned by the back-end logger.
	The back-end logger tags the data with a timestamp, and writes it
	to /var/log/sudoscript. Every 30 seconds, the backend logger checks
	the size of the log file, and forks a rotater/compressor if the 
	size exceeds 2MB. When sudoshell's script(1) exits, sudoshell informs
	the master daemon of this and exits. The master daemon sends a SIGHUP
	to the associated session daemon, which unlinks the session FIFO and 
	exits. If the master daemon receives a SIGHUP, it signals all 
	outstanding session daemons and the backend logger, each of which
	clean up and exit in response. The master daemon then exits.
*Mon May 21 2002 hbo
	Branched 1.0 onto BRANCH_1_0
*Thu May  2 2002 sudoscript v 1.0.4 hbo
-	Release changes detailed below
*Thu May  2 2002 hbo
-	Reorganize Makefile a lot
*Thu May  2 2002 hbo
-	Reorganize Makefile a little
*Thu May  2 2002 hbo
-	Add PROBLEMS doc calling out some shortcomings
*Thu May  2 2002 hbo
- 	Change Makefile to not use sudo when euid is root
-	per a suggestion from Chan Wilson
*Thu May  2 2002 cwilson
-	Add SGI install instructions to INSTALL
*Wed May  1 2002 hbo
-	Change Irix install path to /usr/local so as not to conflict
-	with any SGI Freeware release that might emerge
*Wed Apr 24 2002 hbo
-	Update PORCMOLSULB, README and sudoshell POD to reflect the 
-	real explanations of why cd and globbing fail
*Wed Apr 24 2002 hbo
-	Hack PORTING to reflect Chan's changes and devel mailing list
*Wed Apr 24 2002 hbo
-	Hack Makefile to install on Irix
*Wed Apr 24 2002 cwilson
- 	sudoshell
-	Add code to recognize Irix for daemon startup 
*Wed Apr 24 2002 cwilson
-	Add Irix init script
*Wed Apr 24 2002 cwilson
-	sudoshell/sudoscriptd
-	Fix non-functional '|| die' constructs
*Tue Apr 23 2002 sudoscript v 1.0.3 hbo
- 	*Sigh* Just packaging issues. The previous RPM and dist work fine.
- 	The web page just points to the wrong RPMS and dist.
*Tue Apr 23 2002 sudoscript v 1.0.2 hbo
- 	Non-security bug in sudoscriptd computation of log file size squashed
*Mon Apr 22 2002 sudoscript v 1.0.1 hbo
-	A couple of functional changes. Mainly a documentation release.
-	Added PORCMOLSULB.[xml|html|pdf], a paper describing why I wrote
-	sudoscript. Due for publication in ;login.
*Mon Apr 22 2002 hbo
-	sudoshell
-	use 'ps -auxww' on Linux. Refixes Solaris 7 fix. 8)
*Mon Apr 15 2002 hbo
-	sudoshell
-	use 'ps -ef' rather than 'ps -elf'. Fixes daemon start
-	from ss on Solaris 7.
*Mon Apr 15 2002 hbo
- 	sudoscriptd
-	Create /var/run and /var/run/sudoscript if they don't exist
-	Fixes daemon startup from ss on Solaris 7
*Fri Apr 12 2002 hbo
-	sudoshell
-	Second check of root was redundant
*Fri Apr 12 2002 hbo
- 	sudoscriptd
-	Document uglyness of script(1) output
*Fri Apr 12 2002 hbo
- 	sudoscriptd
-	Fix documentation. Timestamps will NOT help sort out
-	multiple users.
*Fri Apr 12 2002 hbo
- 	sudoscriptd
-	Handle return value of rotate_log() consistently.
* Tue Apr 02 2002 Howard Owen
- Created version 1.0
